var MDLMixin = {
    componentDidMount: function() {
        componentHandler.upgradeElement(this.getDOMNode());
    },
    componentDidUpdate: function(prevProps, prevState){
        componentHandler.upgradeElement(this.getDOMNode());
    }
}

var Byline = React.createClass({
    render: function(){
        return (
            <div className='byline'>
                <table>
                <tbody>
                <tr><th>취재, 글</th><td>
                    <a href='http://newstapa.org/author/kangminq' target='_blank'>김강민</a>
                    <a href='http://newstapa.org/author/muckraker' target='_blank'>김용진</a>
                    <a href='http://newstapa.org/author/pjseok' target='_blank'>박중석</a>
                    <a href='http://newstapa.org/author/siskra' target='_blank'>송원근</a>
                    <a href='http://newstapa.org/author/inbo' target='_blank'>심인보</a>
                    <a href='http://newstapa.org/author/boram' target='_blank'>이보람</a>
                    <a href='http://newstapa.org/author/soulabe' target='_blank'>최윤원</a>
                </td></tr>
                <tr><th>  디자인</th><td>
                    <a href='http://newstapa.org/author/gracemj' target='_blank'>최미정</a>
                </td></tr>
                <tr><th>    사진</th><td>
                    <a href='http://newstapa.org/author/nbkim128' target='_blank'>김남범</a>
                    <a href='http://newstapa.org/author/start' target='_blank'>최형석</a>
                </td></tr>
                <tr><th>    출판</th><td>
                    <a href='http://newstapa.org/author/guarder' target='_blank'>임종헌</a>
                </td></tr>
                <tr><th>자료조사</th><td>
                    <a>김민정</a>
                    <a>김태민</a>
                    <a>박단비</a>
                    <a>박주은</a>
                    <a>임세지</a>
                    <a>서가람</a>
                    <a>정상석</a>
                    <a>제희원</a>
                </td></tr>
                <tr><th>자료제공</th><td>
                    <a href='http://www.minjok.or.kr' target='_blank'>민족문제연구소</a>
                </td></tr>
                </tbody>
                </table>
            </div>
        );
    }
});

var Footer = React.createClass({
    mixins: [MDLMixin],
    render: function() {
        return (
        <footer className='mdl-mega-footer'>
          <div className='mdl-mega-footer__middle-section'>
            <div className='mdl-mega-footer__drop-down-section'>
              <ul className='mdl-mega-footer__link-list'>
                <li><a href='http://welcome.newstapa.org'>소개</a></li>
                <li><a href='http://newstapa.org/using'>콘텐츠 사용원칙</a></li>
                <li><a href='http://eharu616.org/display/award?year=2013'>디지털유산 어워드</a></li>
              </ul>
            </div>

            <div className='mdl-mega-footer__drop-down-section'>
              <ul className='mdl-mega-footer__link-list'>
                <li><a href='http://welcome.newstapa.org/notice'>알립니다.</a></li>
                <li><a href='http://welcome.newstapa.org/contact_us'>제휴.협력 문의</a></li>
                <li><a href='http://recruit.newstapa.org/'>채용</a></li>
                <li><a href='http://welcome.newstapa.org/contact_us'>인터뷰, 강의, 취재 요청</a></li>
              </ul>
            </div>

            <div className='mdl-mega-footer__drop-down-section'>
              <p>
                서울특별시 마포구 서강로 82 벽송빌딩 6층(121-881), 한국탐사저널리즘센터
                <br />
                사업자등록번호 : 117-82-66835 | 인터넷신문등록번호 : 서울,아02778 (2013년 8월 21일)
              </p>
            </div>

            <div className='mdl-mega-footer__drop-down-section'>
              <p>
                대표자: 김용진 | 발행인/편집인:김용진 | 개인정보관리 책임자 : 김성근
                <br />
                Tel 02-2038-0977 | Fax 02-2038-0978 | <a href='mailto:webmaster@newstapa.org'>webmaster@newstapa.org</a>
              </p>
            </div>
          </div>

          <div className='mdl-mega-footer__bottom-section'>
            <div className='mdl-logo'><a href='http://newstapa.org' target='_blank'>한국탐사저널리즘센터: 뉴스타파</a></div>
            <ul className='mdl-mega-footer__link-list'>
              <li>제작: <a href='mailto:dev@newstapa.org'>"뉴스타파 개발팀" &lt;dev@newstapa.org&gt;</a></li>
            </ul>
          </div>

        </footer>
        );
    }
});


var MenuBar = React.createClass({
    mixins: [ReactRouter.State],
     render: function() {
        return (<div className='chapters-menu'>
            <ul>
                <li className='item title'>친일과 망각</li>
                {CHAPTERS.map(function(o, index) {
                    return (
                    <li
                        key={index}
                        className={'item chapter ' + (o.url ? '' : 'disabled')}
                        onClick={this.onClickChapter.bind(this, index + 1, ! Boolean(o.url))}
                    >
                        <span className='seq'>제{index + 1}부</span><span className='subject'>{o.subject}</span>
                    </li>);
                }.bind(this))}
                <li className='item'><a className='subject' href='https://newstapa.org/tags/%EC%B9%9C%EC%9D%BC%EA%B3%BC%EB%A7%9D%EA%B0%81' target='_blank'>방송 보기</a></li>
                <li className='item'><a className='subject' href='/#/discuss'>토론</a></li>
            </ul>
        </div>);
    },
    onClickChapter: function(chapter, disabled) {
        if (disabled) return;

        if (this.getParams().chapter == chapter.toString()) {
            return;
        }

        $('#content').addClass('is-active');
        $('#spinner').addClass('is-active');

        if ($('.chapter .content').length < 1) {
            ROUTER.transitionTo('/:chapter', {chapter: chapter});
            return;
        }

        $('.chapter .content').fadeOut(1000, function() {
            ROUTER.transitionTo('/:chapter', {chapter: chapter});
        });
    }
});


var Application = React.createClass({
    mixins: [MDLMixin],
    getDefaultProps: function() {
        return {
            title: '친일과 망각',
            hashTags: [
                '뉴스타파',
                '친일파'
            ]
        }
    },
    render: function() {
        return (
        <div className='layout-transparent mdl-layout mdl-js-layout mdl-layout--fixed-header'>
            <header className='mdl-layout__header  mdl-layout__header--transparent'>
                <div className='mdl-layout__header-row'>
                    <a target='_blank' className='mdl-layout-title' href='http://newstapa.org'></a>
                    <div className='mdl-layout-spacer'></div>
                    <nav className='mdl-navigation share'>
                        <div className='btn fb' onClick={this.onClickFacebook} />
                        <div className='btn tw' onClick={this.onClickTwitter} />
                        <div className='btn ks' onClick={this.onClickKS} />
                    </nav>
                    <nav className='mdl-navigation donate'>
                        <a className='mdl-navigation__link' href='http://newstapa.org/donate' target='_blank'>후원하기</a>
                    </nav>
                </div>
                <div className='mdl-layout__header-row chapters-menu-block'>
                    <MenuBar />
                </div>
            </header>
            <div className='mdl-layout__drawer'>
                <span className='mdl-layout-title'>{this.props.title}</span>
                <nav className='mdl-navigation'>
                    {CHAPTERS.map(function(o, index) {
                        return <a key={index} className='mdl-navigation__link'
                                disabled={o.url ? '' : 'true'}
                                href={'/#/' + (index + 1)}
                            >제{index + 1}부 {o.subject}</a>;
                    }.bind(this))}
                    <a className='mdl-navigation__link' href='https://newstapa.org/tags/%EC%B9%9C%EC%9D%BC%EA%B3%BC%EB%A7%9D%EA%B0%81' target='_blank'>방송 보기</a>
                    <a className='mdl-navigation__link' href='/#/discuss'>토론 하기</a>
                </nav>

            </div>
            <main className='mdl-layout__content'>
                {
                    (isIE() || isMobile())?
                        <div className='front-panel-done' />
                    :
                    (<span>
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel' />
                        <div className='front-panel fixed' />
                    </span>)
                }

                <MenuBar />

                <ReactRouter.RouteHandler />

            <Footer />
            </main>
        </div>);
    },
    componentDidMount: function() {
        $('.mdl-layout__content').unbind('scroll');
        if ($(document.body).width() < 769) {
            return;
        }

        $('.mdl-layout__content').on('scroll', function(e) {
            var headerHeight = $('.mdl-layout__header').height();
            var chaptersTop = $('.mdl-layout__content > .chapters-menu').offset().top;
            var chaptersHeight = $('.mdl-layout__content > .chapters-menu').height();
            var offset = chaptersTop - headerHeight + chaptersHeight;

            var header = $('.mdl-layout__header');
            var menu_block = $('.mdl-layout__header-row.chapters-menu-block');
            var menu = $('.mdl-layout__content > .chapters-menu');
            if (offset < 0) {
                header.addClass('active');
                menu_block.addClass('active');
                menu.addClass('deactive');
            } else {
                header.removeClass('active');
                menu_block.removeClass('active');
                menu.removeClass('deactive');
            }
        });
    },
    onClickTwitter: function() {
        var hashTagList = [];
        this.props.hashTags.forEach(function(i) {
            hashTagList.push(encodeURIComponent(i));
        });
        var hashTags = hashTagList.join(',');
        var title = encodeURIComponent('"' + this.props.title + '"');

        window.open(
            'https://twitter.com/share?text=' + title + '&hashtags=' + hashTags + '&url=http://815.newstapa.org',
            '',
            'width=550,height=450,left='+((screen.width-550)/2)+',top=200,resizable=yes,scrollbars=yes'
        );
        return;
    },
    onClickFacebook: function() {
        window.open(
            'https://www.facebook.com/sharer/sharer.php?u=http://815.newstapa.org',
            '',
            'width=626,height=436,left='+((screen.width-626)/2)+',top=200,resizable=yes,scrollbars=yes'
        );
        return;
    },
    onClickKS: function() {
        window.open('https://story.kakao.com/ch/newstapa', '_blank');
        return;
    }
});

var BaseDdangMap = {
    getValue: function(d) {
        var v = this.defaults.data[d.properties.code];
        return v ? v : 0;
    },
    render: function() {
        return <div className={this.defaults.kind} />;
    },
    componentDidMount: function() {
        this.initializeMap(this.getDOMNode());
        this.show(1000);
    },
    getTextColorPercent: function(code) {
        var value = this.defaults.data[code];
        return 90 * ((value ? value : 0) / this.defaults.max);
    },
    getTextColor: function(baseColor, code, increase) {
        var v = this.getTextColorPercent(code);
        return decrease_brightness(baseColor, v);
    }
}

var DdangMap = React.createClass({
    mixins: [MDLMixin],
    getInitialState: function() {
        return {
            kind: 'korea'
        }
    },
    render: function() {
        var map;
        if (this.state.kind == 'korea') {
            map = <KoreaDdangMap ref='current' key='korea' />;
        } else if (this.state.kind == 'seoul') {
            map = <SeoulDdangMap ref='current' key='seoul' />;
        }

        return (<div className='viz ddang-map'>
            <div className='mdl-grid viz-header'>
                <div className='mdl-cell mdl-cell--3-col mdl-cell--1-col-phone'></div>
                <div className='mdl-cell mdl-cell--6-col mdl-cell--10-col-phone'>
                    <h4>친일파 후손 거주지 분석</h4>
                </div>
                <div className='mdl-cell mdl-cell--3-col mdl-cell--1-col-phone'></div>
            </div>
            <div className='mdl-grid'>
                <div className='mdl-cell mdl-cell--12-col mdl-grid--no-spacing'>
                    <div className='move-button'>
                        <button
className='mdl-button mdl-js-button mdl-button--raised mdl-button--accent mdl-js-ripple-effect'
onClick={this.onClickChange}
>
                        {this.state.kind == 'korea' ?
                            '서울 지역을 자세히 볼 수 있습니다.'
                        :
                            '전 지역으로 돌아갑니다.'
                        }
                        </button>
                    </div>
                    <div className='content'>
                    {map}
                    </div>
                </div>
            </div>
        </div>);
    },
    onClickChange: function() {
        this.refs.current.hide(2000, function() {
            var next = 'korea';
            if (this.state.kind == 'korea') {
                next = 'seoul';
            }
            this.setState({kind: next});
        }.bind(this));
    }
});

var KoreaDdangMap = React.createClass({
    mixins: [MDLMixin, BaseDdangMap],
    getDefaultProps: function() {
        return {
            map_json: SKOREA_MUNICIPALITIES_TOPO_SIMPLE_JSON
        }
    },
    componentWillMount: function() {
        this.defaults = {
            kind: 'korea',
            zoomCenter: [126.943187, 37.549082],
            center: [128.062451, 36.515271],
            data: DDANG_MAP_DATA_KOREA,
            width: null,
            height: null,
            maxHeight: 700,
            mapRatio: 2,
            mapScaleRatio: 7,
            pathColor: '#efefef',

            objects: {},

            max: null
        }
    },
    hide: function(duration, callback) {
        var x = this.defaults.width / 2;
        var y = this.defaults.height / 2;
        var c = this.projection(this.defaults.zoomCenter);

        this.svg
            .transition()
            .duration(duration)
            .attr('fill-opacity', 0.01)
            .attr('stroke-opacity', 0.01)
            .each('end', function() {
                d3.select(this).selectAll('*').remove();
                if (callback) callback();
            });
        ;

        this.svg
            .selectAll('path')
            .transition()
            .duration(duration)
            .attr('transform', 'translate(' + x + ', ' + y + ') scale('  + 3 + ') translate(' + -c[0] + ',' + -c[1] + ')')
        ;

        this.svg
            .selectAll('text')
            .transition()
            .duration(duration)
            .attr('fill-opacity', 0.01)
            .attr('stroke-opacity', 0.01)
        ;
    },
    show: function(duration) {
        this.svg
            .transition()
            .duration(duration)
            .attr('fill-opacity', 1)
            .attr('stroke-opacity', 1)
        ;

        this.svg
            .selectAll('text')
            .transition()
            .duration(duration)
            .attr('fill-opacity', 1)
            .attr('stroke-opacity', 1)
        ;
    },
    initializeMap: function(body) {
        this.props.map_json.objects.skorea_provinces_geo.geometries.forEach(function(i) {
            var o = {
                code: i.properties.code,
                name: i.properties.name,
                name_eng: i.properties.name_eng,
                value: 0
            }
            this.defaults.objects['gu-' + o.code] = o;
        }.bind(this));

        this.defaults.max = d3.max(d3.entries(this.defaults.data), function(d) { return d.value; });

        var w, h;
        w = $(body).width();
        h = w * this.defaults.mapRatio;
        if (h > this.defaults.maxHeight) {
            h = this.defaults.maxHeight;
        }
        h -= 70;

        this.defaults.width = w;
        this.defaults.height = h;

        this.svg = d3.select(body)
            .append('svg')
            .attr('width', this.defaults.width)
            .attr('height', this.defaults.height)
            .attr('transform', 'translate(0, 0) scale(1)')
            .attr('fill-opacity', 0)
            .attr('stroke-opacity', 0)
        ;

        this.projection = d3.geo.mercator()
            .center(this.defaults.center)
            .scale(this.defaults.height * this.defaults.mapScaleRatio)
            .translate([this.defaults.width / 2, this.defaults.height / 2])
        ;

        var path = d3.geo.path().projection(this.projection);

        var features = topojson.feature(
            this.props.map_json,
            this.props.map_json.objects.skorea_provinces_geo
        ).features;

        var _this = this;
        var g = this.svg
            .selectAll('.g')
            .data(features)
            .enter()
        ;

        g
            .append('path')
            .attr('class', function(d) {
                var cls = 'area c-' + d.properties.code;
                var o = _this.getValue(d);
                if (o > 0 && d.properties.code == 11) {
                    cls += ' active';
                }
                return cls;
            })
            .attr('d', path)
            .attr('fill', this.defaults.pathColor)
            .on('click', function(d) {
                var o = _this.getValue(d);
                if (o < 1 || d.properties.code != 11) return;
            })
        ;

        g
            .append('text')
            .attr('class', 'name')
            .attr('fill-opacity', 0)
            .attr('transform', function(d) {
                return 'translate(' + path.centroid(d) + ')';
            })
            .attr('dy', function(d) {
                if (d.properties.code == 31) {
                    return '3em';
                }
            })
            .attr('fill', function(d) {
                return '#f79f9f';
            })
            .text(function(d) {
                var o = this.getValue(d);
                if (o < 1) return;
                return d.properties.name;
            }.bind(this))
        ;

        g
            .append('text')
            .attr('class', 'value')
            .attr('fill-opacity', 0)
            .attr('dx', function(d, index) {
                var o = this.getValue(d);
                if (o < 1) return;

                if (d.properties.code == 31) {
                    return '-1.6em';
                }
                var s = o ? o : '';
                var v = s.toString().length * 0.1;
                var v = '-' + v.toString() + 'em';

                return v;
            }.bind(this))
            .attr('dy', function(d) {
                var o = this.getValue(d);
                if (o < 1) return;

                if (d.properties.code == 31) {
                    return '1em';
                }
                return '-0.5em';
            }.bind(this))
            .attr('transform', function(d) {
                return 'translate(' + path.centroid(d) + ')';
            })
            .attr('fill', function(d) {
                var p = this.getTextColorPercent(d.properties.code);
                if (p > 50) {
                    var v = increase_brightness('#421414', p > 60 ? 60 : p);
                } else {
                    var v = decrease_brightness('#f79f9f', p);
                }
                return v;
            }.bind(this))
            .text(function(d) {
                var o = this.getValue(d);
                return o ? o : '';
            }.bind(this))
        ;

        this.svg
            .selectAll('path.active')
            .attr('fill', '#7f6af9')
        ;
    }
});

var SeoulDdangMap = React.createClass({
    mixins: [MDLMixin, BaseDdangMap],
    getDefaultProps: function() {
        return {
            map_json: SEOUL_SUBMUNICIPALITIES_TOPO_SIMPLE_JSON
        }
    },
    componentWillMount: function() {
        this.defaults = {
            kind: 'seoul',
            zoomCenter: [126.943187, 37.549082],
            center: [127.005037, 37.555041],
            data: DDANG_MAP_DATA_SEOUL,
            width: null,
            height: null,
            maxHeight: 700,
            mapRatio: 1.22,
            mapScaleRatio: 133,

            objects: {},

            max: null
        }
    },
    hide: function(duration, callback) {
        var x = this.defaults.width / 2;
        var y = this.defaults.height / 2;
        var c = this.projection(this.defaults.zoomCenter);

        this.svg
            .transition()
            .duration(duration)
            .attr('fill-opacity', 0.01)
            .attr('stroke-opacity', 0.01)
            .each('end', function() {
                d3.select(this).selectAll('*').remove();
                if (callback) callback();
            });
        ;

        this.svg
            .selectAll('path')
            .transition()
            .duration(duration)
            .attr('transform', 'translate(' + x + ', ' + y + ') scale('  + 3 + ') translate(' + -c[0] + ',' + -c[1] + ')')
        ;

        this.svg
            .selectAll('text')
            .transition()
            .duration(duration)
            .attr('fill-opacity', 0.01)
            .attr('stroke-opacity', 0.01)
        ;
    },
    show: function(duration) {
        this.svg
            .transition()
            .duration(duration)
            .attr('fill-opacity', 1)
            .attr('stroke-opacity', 1)
        ;

        this.svg
            .selectAll('text')
            .transition()
            .duration(duration)
            .attr('fill-opacity', 1)
            .attr('stroke-opacity', 1)
        ;
    },
    initializeMap: function(body) {
        this.props.map_json.objects.seoul_submunicipalities_geo.geometries.forEach(function(i) {
            var o = {
                code: i.properties.code,
                name: i.properties.name,
                name_eng: i.properties.name_eng,
                value: 0
            }
            this.defaults.objects['gu-' + o.code] = o;
        }.bind(this));

        this.defaults.max = d3.max(d3.entries(this.defaults.data), function(d) { return d.value; });

        this.defaults.width = $(body).width();
        this.defaults.height = this.defaults.width / this.defaults.mapRatio;
        if (this.defaults.height > this.defaults.maxHeight) {
            this.defaults.height = this.defaults.maxHeight;
            this.defaults.width = this.defaults.height * this.defaults.mapRatio;
        }

        this.svg = d3.select(body)
            .append('svg')
            .attr('width', this.defaults.width)
            .attr('height', this.defaults.height)
            .attr('fill-opacity', 0)
        ;

        this.projection = d3.geo.mercator()
            .center(this.defaults.center)
            .scale(this.defaults.width * this.defaults.mapScaleRatio)
            .translate([this.defaults.width / 2, this.defaults.height / 2])
        ;

        var path = d3.geo.path().projection(this.projection);

        var features = topojson.feature(
            this.props.map_json,
            this.props.map_json.objects.seoul_submunicipalities_geo
        ).features;

        var _this = this;
        var g = this.svg
            .selectAll('.g')
            .data(features)
            .enter()
        ;

        g
            .append('path')
            .attr('class', function(d) {
                return 'area c-' + d.properties.code;
            })
            .attr('d', path)
            .attr('fill', function(d) {
                return this.getTextColor('#efefef', d.properties.code);
            }.bind(this))
        ;

        g
            .append('text')
            .attr('class', 'name')
            .attr('fill-opacity', 0)
            .attr('transform', function(d) {
                return 'translate(' + path.centroid(d) + ')';
            })
            .attr('dy', '.35em')
            .attr('fill', function(d) {
                var p = this.getTextColorPercent(d.properties.code);
                if (p > 50) {
                    var v = increase_brightness('#421414', p > 60 ? 60 : p);
                } else {
                    var v = decrease_brightness('#f79f9f', p);
                }
                return v;
            }.bind(this))
            .text(function(d) {
                if (this.getValue(d) < 1) {
                    return;
                }
                return d.properties.name;
            }.bind(this))
        ;

        g
            .append('text')
            .attr('class', 'value')
            .attr('fill-opacity', 0)
            .attr('dx', function(d, index) {
                var o = this.defaults.data[d.properties.code];
                var s = o ? o : '';
                var v = s.toString().length * 0.1;
                var v = '-' + v.toString() + 'em';

                return v;
            }.bind(this))
            .attr('dy', '-0.35em')
            .attr('transform', function(d) {
                return 'translate(' + path.centroid(d) + ')';
            })
            .attr('fill', function(d) {
                var p = this.getTextColorPercent(d.properties.code);
                if (p > 50) {
                    var v = increase_brightness('#421414', p > 60 ? 60 : p);
                } else {
                    var v = decrease_brightness('#f79f9f', p);
                }
                return v;
            }.bind(this))
            .text(function(d) {
                var o = this.defaults.data[d.properties.code];
                return o ? o : '';
            }.bind(this))
        ;
    }
});

var DdangBack = React.createClass({
    mixins: [MDLMixin],
    getDefaultProps: function() {
        return {
            autoPlay: false,
            maxHeight: 500,
            legendHeight: 100,
            paddingBottom: 10,
            paddingText: [10, 3],
            textSize: 10,
            minSize: 10,
            padding: 10,
            colors: [],
            beat: {
                duration: 80,
                count: 20
            }
        }
    },
    getInitialState: function() {
        return {
            dataset: [],
            isPlaying: false
        }
    },
    componentDidUpdate: function() {
        if (this.state.dataset.length < 1) return;

        this.update(this.state.dataset);
    },
    render: function() {
        var isPlaying = this.state.isPlaying ? 'deactive' : 'active';

        return (<div className='viz ddang-back'>
            <div className='mdl-grid viz-header'>
                <div className='mdl-cell mdl-cell--3-col mdl-cell--1-col-phone'></div>
                <div className='mdl-cell mdl-cell--6-col mdl-cell--10-col-phone'>
                    <h4>친일파의 땅, 얼마나 환수했을까?</h4>
                </div>
                <div className='mdl-cell mdl-cell--3-col mdl-cell--1-col-phone'></div>
            </div>
            <div className='mdl-grid'>
                <div className='mdl-cell mdl-cell--12-col mdl-grid--no-spacing'>
                    <button
                        className={'mdl-button mdl-js-button mdl-button--fab mdl-button--colored play-button ' +
                            (this.state.isPlaying ? 'paused' : '')}
                        onClick={this.onClickPlay}
                        >
                        <i className='material-icons'>{this.state.isPlaying ? 'pause' : 'play_arrow'}</i>
                    </button>
                    <div className='content'></div>
                </div>
            </div>
        </div>);
    },
    componentWillMount: function() {
        this.defaults = {
            height: 0,
            width: 0,
            innerHeight: null,
            paddingLeft: 0,
            maxSize: 200,
            data: [
                {value: 1350000,    label: '국가 귀속 뒤 매각', desc: '135만㎡'},
                {value: 13000000,   label: '국가 귀속 토지', desc: '1,300만㎡'},
                {value: 21810000,   label: '친일재산조사위 조사 대상 토지', desc: '2,181만㎡'},
                {value: 430000000,  label: '친일파 소유 토지(추정)', desc: '4억3천만㎡'}
            ],
            playingData: []
        }
    },
    componentDidMount: function() {
        var body = $(this.getDOMNode()).find('.content').get();
        this.initializeCanvas(body[0]);

        var sequantialData = [];
        for (var i = 0; i < this.defaults.data.length; i++) {
            var newData = this.defaults.data.slice();
            newData.forEach(function(d, index) {
                newData[index] = $.extend({}, newData[index]);
                if (i + 1 > index) return;
                newData[index].value = 0;
            });
            sequantialData.push(newData);
        }

        this.draw();

        // show the 1st circle at 1st time.
        if (this.defaults.playingData.length < 1) {
            this.defaults.playingData = this.makePlayData();
        }

        var o = this.defaults.playingData.shift();
        this.setState({dataset: this.makeDataset(o)});

        if (this.props.autoPlay) {
            setTimeout(this.play, 1000);
        }
    },
    getBlankData: function() {
        var blankData = [];
        this.defaults.data.forEach(function(d) {
            var n = $.extend({}, d);
            n.value = 0;

            blankData.push(n)
        });

        return blankData;
    },
    makeDataset: function(data) {
        var sorted = data.slice().sort(function (a, b) { return (a.value - b.value);});
        return {
            data: data,
            max: sorted[sorted.length - 1],
            maxIndex: data.indexOf(sorted[sorted.length - 1])
        }
    },
    prepareData: function(data) {
        // set color
        data.forEach(function(d, index) {
            var color = decrease_brightness('#ffffff', 10 * ((index + 1) / data.length));
            var name = 'gradient' + index;
            this.props.colors.push({name: name, value: color});
        }.bind(this));

        return data;
    },
    initializeCanvas: function(body) {
        this.defaults.data = this.prepareData(this.defaults.data);

        this.defaults.width = $(body).width();
        this.defaults.height = this.defaults.width;
        if (this.defaults.height > this.props.maxHeight) {
            this.defaults.height = this.props.maxHeight;
        }

        this.defaults.innerHeight = this.defaults.height - this.props.paddingBottom;

        this.svg = d3.select(body)
        .append('svg')
        .attr('width', this.defaults.width)
        .attr('height', this.defaults.height)

        this.props.colors.forEach(function(color) {
            var gradient = this.svg
                .append('svg:defs')
                .append('svg:radialGradient')
                .attr('id', color.name)
                .attr('x1', '0%')
                .attr('y1', '0%')
                .attr('x2', '100%')
                .attr('y2', '100%')
                .attr('spreadMethod', 'pad')
            ;

            gradient.append('svg:stop')
                .attr('offset', '0%')
                .attr('stop-color', color.value)
                .attr('stop-opacity', 1)
            ;

            gradient.append('svg:stop')
                .attr('offset', '50%')
                .attr('stop-color', decrease_brightness(color.value, 5))
                .attr('stop-opacity', 1)
            ;

            gradient.append('svg:stop')
                .attr('offset', '100%')
                .attr('stop-color', decrease_brightness(color.value, 10))
                .attr('stop-opacity', 1)
            ;
        }.bind(this));

        // calculate maxSize
        var dataset = this.makeDataset(this.defaults.data);
        var lastCx;
        var lastRadius;
        while (true) {
            var r = this.getRadius(dataset, dataset.maxIndex, dataset.max);
            var w = this.getCx(
                dataset,
                dataset.maxIndex,
                dataset.max
            );

            if ((w + r) > this.defaults.width - 50 - this.defaults.paddingLeft) {
                lastCx = w + r;
                lastRadius = r;
                break;
            }
            this.defaults.maxSize += 5;
        }

        // the halfed circle will be exaggerated.
        if ((lastRadius * 2) > this.defaults.innerHeight - 10 - this.props.legendHeight) {
            while ((lastRadius * 2) > this.defaults.innerHeight - 10 - this.props.legendHeight) {
                this.defaults.maxSize -= 5;

                var r = this.getRadius(dataset, dataset.maxIndex, dataset.max);
                var w = this.getCx(
                    dataset,
                    dataset.maxIndex,
                    dataset.max
                );

                lastCx = w + r;
                lastRadius = r;
            }
        }

        // get side padding
        this.defaults.paddingLeft = (this.defaults.width - lastCx) / 2;
    },
    getRadius: function(dataset, index, d) {
        if (d.value == 0) {
            return 0;
        }
        var v = this.defaults.maxSize * (d.value / dataset.max.value);

        if (v < this.props.minSize) {
            var a = dataset.data.length - index;
            v = this.props.minSize - (a * a);
            if (v < (index + 1)) {
                return index + 1;
            }
        }

        return v;
    },
    getCx: function(dataset, index, d) {
        var r = this.getRadius(dataset, index, d);

        if (index < 1) {
            return this.defaults.paddingLeft + r + this.props.padding;
        }

        var prevRadius = this.getRadius(dataset, index - 1, dataset.data[index -1]);
        var prev = this.getCx(dataset, index - 1, dataset.data[index -1]);
        return r + prev + prevRadius + this.props.padding;
    },
    getCy: function(dataset, index, d) {
        var r = this.getRadius(dataset, index, d);
        return this.defaults.innerHeight - this.props.legendHeight - r;
    },
    getLabelCy: function(label, index) {
        var v = index * (d3.select(label).node().getBBox().height + (this.props.paddingText[1] * 2));
        return this.defaults.innerHeight - v;
    },
    startBeat: function() {
        if (this.beatRunning) return;

        var circle_1st = d3.select(this.svg.selectAll('.circle-1st')[0][0]);
        this.svg
            .selectAll('.g')
            .append('circle')
            .attr('class', 'beat-dot')
            .attr('cx', circle_1st.attr('cx'))
            .attr('cy', circle_1st.attr('cy'))
            .attr('r', 1)
            .attr('fill', '#000')
        ;

        this.beatRunning = true;
        this._beat();
    },
    endBeat: function() {
        this.beatRunning = false;

        this.svg.selectAll('.beat-dot').transition();
        this.svg.selectAll('.beat-circle').transition();

        this.svg.selectAll('.beat-dot').remove();
        this.svg.selectAll('.beat-circle').remove();
    },
    _beat: function (circle, n) {
        if (typeof circle == 'undefined') {
            var circle_1st = d3.select(this.svg.selectAll('.circle-1st')[0][0]);
            circle = this.svg
                .selectAll('.g')
                .append('circle')
                .attr('class', 'beat-circle')
                .attr('cx', circle_1st.attr('cx'))
                .attr('cy', circle_1st.attr('cy'))
                .attr('r', 1)
                .attr('fill', 'red')
                .attr('fill-opacity', 0.1)
            ;
        }

        if (typeof n == 'undefined') {
            n = 0;
        }

        if (! this.beatRunning) {
            this.endBeat();
            return;
        }

        var v = 2 * (n % (this.props.beat.count / 2));
        var d = this.props.beat.duration;
        if ((n % (this.props.beat.count / 2)) != 0) {
            d -= 70 / (n % (this.props.beat.count / 2));
        }

        circle
            .transition()
            .duration(d)
            .attr('r', v < 1 ? 1 : v)
            .each('end', function() {
                if (n < this.props.beat.count) {
                    this._beat(circle, n + 2);
                    return;
                }

                this.endBeat();
                setTimeout(function() {
                    this.startBeat();
                }.bind(this), 700);
            }.bind(this))
        ;
    },
    makePlayData: function() {
        var sequantialData = [];
        for (var i = 0; i < this.defaults.data.length; i++) {
            var newData = this.defaults.data.slice();
            newData.forEach(function(d, index) {
                newData[index] = $.extend({}, newData[index]);
                if (i + 1 > index) return;
                newData[index].value = 0;
            });
            sequantialData.push(newData);
        }

        return sequantialData;
    },
    play: function() {
        this.endBeat();

        if (this.defaults.playingData.length < 1) {
            this.defaults.playingData = this.makePlayData();
        }

        this.setState({isPlaying: true}, this._play);
    },
    _play: function() {
        if (! this.state.isPlaying) return;

        var o = this.defaults.playingData.shift();
        if (! o) {
            this.setState({isPlaying: false, dataset: []});
            return;
        }

        this.setState({dataset: this.makeDataset(o)});

        setTimeout(function() {
            this._play();
        }.bind(this), 3000);
    },
    onClickPlay: function() {
        if (this.state.isPlaying) {
            this.setState({isPlaying: false});
        } else {
            this.play();
        }
    },
    draw: function() {
        var g = this.svg
            .selectAll('.g')
            .data(this.getBlankData())
            .enter()
        ;

        var g = g
            .append('g')
            .attr('class', 'g')
        ;

        g
            .append('circle')
            .attr('class', function(d, index) {
                if (index != 0) return;

                return 'circle-1st';
            })
            .attr('cx', 1)
            .attr('cy', 1)
            .attr('r', 1)
            .style('fill', '#fff')
            .style('stroke', '#888')
        ;

        g
            .append('text')
            .attr('class', 'desc')
            .attr('fill-opacity', 0)
            .attr('fill', 'grey')
            .text(function(d) {
                return d.desc;
            })
        g
            .append('line')
            .attr('class', 'line-v')
        ;

        g
            .append('line')
            .attr('class', 'line-h')
        ;

        g
            .append('text')
            .attr('class', 'label')
            .attr('fill-opacity', 0)
            .attr('fill', 'grey')
            .text(function(d) {
                return d.label + ' (' + d.desc + ')';
            })
        ;
    },
    update: function(dataset) {
        if (this.beatRunning) {
            this.endBeat();
        }

        var t = this.svg
            .selectAll('.g')
            .data(dataset.data)
            .transition()
            .duration(1000)
        ;

        t
            .select('circle')
            .attr('cx', function(d, index) {
                return this.getCx(dataset, index, d);
            }.bind(this))
            .attr('cy', function(d, index) {
                return this.getCy(dataset, index, d);
            }.bind(this))
            .attr('r', function(d, index) {
                var r = this.getRadius(dataset, index, d);
                return r;
            }.bind(this))
            .style('fill', function(d, index) {
                return 'url(#gradient' + index.toString() + ')';
            })
            .style('stroke', function(d) {
            })
            .each('start', function(d, index) {
                var label = t.select('.label')[0][index];
                var desc = t.select('.desc')[0][index];
                var line_v = d3.select(t.select('.line-v')[0][index])
                var line_h = d3.select(t.select('.line-h')[0][index])

                if (d.value == 0) {
                    line_v
                        .transition()
                        .duration(1000)
                        .attr('x1', null)
                        .attr('y1', null)
                        .attr('x2', null)
                        .attr('y2', null)
                    ;

                    line_h
                        .transition()
                        .duration(1000)
                        .attr('x1', null)
                        .attr('y1', null)
                        .attr('x2', null)
                        .attr('y2', null)
                    ;
                    d3.select(label).attr('fill-opacity', 0);
                    d3.select(desc).attr('fill-opacity', 0);

                    return;
                }

                var r = this.getRadius(dataset, index, d);
                var x1 = this.getCx(dataset, index, d);
                var y1 = this.getCy(dataset, index, d) + r;
                var x2 = x1;
                var prevY2 = line_v.attr('y2');

                var cy = this.getLabelCy(label, index);
                var y2 = prevY2 == null ? y1 : cy;
                var labelHeightHalf = (d3.select(label).node().getBBox().height / 2);

                line_v
                    .transition()
                    .duration(1000)
                    .attr('x1', x1)
                    .attr('y1', y1)
                    .attr('x2', x2)
                    .attr('y2', y2 - labelHeightHalf)
                ;

                line_h
                    .transition()
                    .duration(1000)
                    .attr('x1', x1)
                    .attr('y1', y2 - labelHeightHalf)
                    .attr('x2', x2 + this.props.paddingText[0] - 5)
                    .attr('y2', y2 - labelHeightHalf)
                ;

                d3.select(desc)
                    .transition()
                    .duration(1000)
                    .attr('x', x2 - (desc.getBBox().width / 2))
                    .attr('y', this.getCy(dataset, index, d))
                    .attr('fill-opacity', function(d) {
                        var opacity = 1;
                        if ((r * 2) < desc.getBBox().width) {
                            opacity = 0;
                        }
                        return opacity;
                    })
                ;
                d3.select(label)
                    .transition()
                    .duration(1000)
                    .attr('x', x2 + this.props.paddingText[0])
                    .attr('y', y2)
                ;

            }.bind(this))
            .each('end', function(d, index) {
                if (d.value == 0) return;

                var t = this.svg
                    .selectAll('.g')
                ;

                var r = this.getRadius(dataset, index, d);
                var x1 = this.getCx(dataset, index, d);
                var y1 = this.getCy(dataset, index, d) + r;
                var x2 = x1;

                var label = t.select('.label')[0][index];
                var desc = t.select('.desc')[0][index];
                var y2 = this.getLabelCy(label, index);

                var labelHeightHalf = (d3.select(label).node().getBBox().height / 2);

                d3.select(t.select('.line-v')[0][index])
                    .transition()
                    .duration(1000)
                    .attr('x1', x1)
                    .attr('y1', y1)
                    .attr('x2', x2)
                    .attr('y2', y2 - labelHeightHalf)
                    .attr('stroke-width', 1)
                    .attr('stroke', 'grey')
                ;

                d3.select(t.select('.line-h')[0][index])
                    .transition()
                    .duration(1000)
                    .attr('x1', x1)
                    .attr('y1', y2 - labelHeightHalf)
                    .attr('x', x2 + this.props.paddingText[0] - 5)
                    .attr('y2', y2 - labelHeightHalf + 5)
                    .attr('stroke-width', 1)
                    .attr('stroke', 'grey')
                ;

                d3.select(label)
                    .transition()
                    .duration(1000)
                    .attr('x', x2 + this.props.paddingText[0])
                    .attr('y', y2)
                    .each('end', function(d) {
                        d3.select(this)
                            .attr('fill-opacity', 1)
                        ;
                    })
                ;

                d3.select(desc)
                    .transition()
                    .duration(10)
                    .attr('x', x2 - (desc.getBBox().width / 2))
                    .attr('y', this.getCy(dataset, index, d))
                    .attr('fill-opacity', function(d) {
                        var opacity = 1;
                        if ((r * 2) < desc.getBBox().width) {
                            opacity = 0;
                        }
                        return opacity;
                    })
                ;

                if (index == 0) {
                    if (r < 3) {
                        this.startBeat();
                    } else {
                        this.endBeat();
                    }
                }
            }.bind(this))
        ;
    }
});

var Exodus = React.createClass({
    componentWillMount: function() {
        this.defaults = {
            data: null,
            isMobile: false,
            highlightRange: [2000, 2011],
            width: null,
            height: null,
            innerWidth: null,
            innerHeight: null,
            minHeight: 350,
            padding: 50,
            margin: {
                top: 60,
                right: 60,
                bottom: 10,
                left: 60
            }
        }
    },
    render: function() {
        return (<div className='viz exodus'>
            <div className='mdl-grid'>
                <div className='mdl-cell mdl-cell--12-col mdl-grid--no-spacing'>
                    <div className='content'>
                    </div>
                </div>
            </div>
        </div>);
    },
    componentDidMount: function() {
        this.initializeChart($(this.getDOMNode()).find('.content').get()[0]);
    },
    prepareData: function() {
        var data = {
            all: [],
            highlight: []
        };
        Object.keys(EXODUS_DATA).forEach(function(k) {
            var d = {
                year: d3.time.format('%Y').parse(k),
                value: EXODUS_DATA[k]
            }

            data.all.push(d);
            if (this.inHighlightRange(d.year)) {
                data.highlight.push(d);
            }
        }.bind(this));

        return data;
    },
    isHighlightRange: function(d) {
        if (d.getFullYear() == this.defaults.highlightRange[0]) {
            return 'start';
        }
        
        if (d.getFullYear() == this.defaults.highlightRange[1]) {
            return 'end';
        }
        return null;
    },
    inHighlightRange: function(d) {
        return d.getFullYear() >= this.defaults.highlightRange[0] && d.getFullYear() <= this.defaults.highlightRange[1];
    },
    initializeChart: function(body) {
        this.defaults.width = $(body).width();
        this.defaults.height = this.defaults.minHeight;

         this.defaults.isMobile = this.defaults.width < 400;
         if (this.defaults.isMobile) {
            this.defaults.margin = {
                top: 5,
                right: 10,
                bottom: 3,
                left: 30
            }
        }

        this.defaults.innerWidth = this.defaults.width - this.defaults.margin.left - this.defaults.margin.right;
        this.defaults.innerHeight = this.defaults.height - this.defaults.margin.top - this.defaults.margin.bottom - (this.defaults.padding * 2);

        var data = this.prepareData();
        this.defaults.dataAll = data.all;
        this.defaults.dataHighlight = data.highlight;

        this.svg = d3.select(body)
            .append('svg')
                .attr('width', this.defaults.width)
                .attr('height', this.defaults.height)
                .attr('transform', 'translate(0, ' + this.defaults.margin.top + ')')
        ;

        this.drawChartAll(body);
    },
    drawChartAll: function(body) {
        var chartAll = this.svg
            .append('g')
                .attr('class', 'all')
                .attr('transform', 'translate(' + this.defaults.margin.left + ', ' + 0 + ')')
        ;


        var x = d3.scale.ordinal().rangeRoundBands([0, this.defaults.innerWidth], 0.05);
        var y = d3.scale.linear().range([this.defaults.innerHeight, 0]);

        var xAxis = d3.svg.axis()
            .scale(x)
            .orient('bottom')
            .tickFormat(function(d) {
                if (! this.defaults.isMobile && d.getFullYear() == this.defaults.dataAll[0].year.getFullYear()) {
                    return d.getFullYear();
                }

                var l = this.defaults.isMobile ? 10 : 5
                var v = d.getFullYear();
                if (v % l) return;
                return v;
            }.bind(this))
        ;
        var yAxis = d3.svg.axis()
            .scale(y)
            .orient('left')
            .tickFormat(function(d) {
                if (d % 10) return;
                return d;
            })
        ;

        x.domain(this.defaults.dataAll.map(function(d) { return d.year; }));
        y.domain([0, d3.max(this.defaults.dataAll, function(d) { return d.value; })]);

        chartAll
            .append('g')
                .attr('transform', 'translate(0,' + (this.defaults.innerHeight + this.defaults.margin.top) + ')')
                .call(xAxis)
                .attr('class', function(d) {
                    return 'x axis';
                })
            .selectAll('text')
                .style('text-anchor', 'end')
                .attr('class', function(d) {
                    if (this.inHighlightRange(d)) {
                        return 'highlight-x';
                    }
                }.bind(this))
                .attr('dx', function() {
                    var r = d3.select(this).node().getBBox();
                    return r.width / 2;
                })
                .attr('dy', function() {
                    var r = d3.select(this).node().getBBox();
                    return r.height;
                })
            ;

        chartAll.append('g')
                .attr('transform', 'translate(0,' + (this.defaults.margin.top) + ')')
                .attr('class', 'y axis')
                .call(yAxis)
            .append('text')
                .attr('x', '-3em')
                .attr('y', '0.35em')
                .text('건수')
        ;

        chartAll.selectAll('.x').selectAll('line')
            .attr('y2', function(d) {
                var v = d.getFullYear();
                if (v % 5 != 0) return;
                return 6;
            })
        ;

        chartAll.selectAll('.y').selectAll('line')
            .attr('x2', function(d) {
                if (d % 10) return;
                return -6;
            })
        ;

        chartAll.selectAll('bar')
            .data(this.defaults.dataAll)
            .enter().append('rect')
            .attr('class', function(d) {
                var t = this.isHighlightRange(d.year);
                if (t) {
                    return 'highlight-' + t;
                }
                return;
            }.bind(this))
            .attr('transform', 'translate(0,' + (this.defaults.margin.top - 1) + ')')
            .attr('x', function(d) {
                return x(d.year);
            })
            .attr('width', x.rangeBand())
            .attr('y', function(d) { return y(d.value); })
            .attr('height', function(d) {
                return this.defaults.innerHeight- y(d.value);
            }.bind(this))
        ;

        // get highlight start and end
        var start = d3.select(chartAll.select('rect.highlight-start')[0][0]).node().getBBox();
        var end = d3.select(chartAll.select('rect.highlight-end')[0][0]).node().getBBox();

        chartAll
            .append('rect')
            .attr('class', 'highlight-area')
            .attr('x', start.x)
            .attr('y', this.defaults.margin.top - 10)
            .attr('width', end.x - start.x)
            .attr('height', this.defaults.innerHeight + 10)
            .on('click', function() {
                var ch = this.svg.selectAll('g.highlight');
                if (ch[0].length > 0) return;

                chartAll
                    .transition()
                    .duration(1000)
                    .attr('transform',
                            'translate(' + this.defaults.margin.left + ', ' +
                                (this.defaults.innerHeight + this.defaults.padding) + ')')
                    .each('start', function() {
                        this.drawChartHighlight(body);
                    }.bind(this))
                ;

                this.svg
                    .transition()
                    .duration(1000)
                    .attr('height', this.defaults.height * 2)
                ;

            }.bind(this))
        ;

    },
    drawChartHighlight: function(body) {
        var chartAll = this.svg
            .append('g')
                .attr('class', 'highlight')
                .attr('transform', 'translate(' + this.defaults.margin.left + ', ' + 0 + ')')
        ;


        var x = d3.scale.ordinal().rangeRoundBands([0, this.defaults.innerWidth], 0.05);
        var y = d3.scale.linear().range([this.defaults.innerHeight, 0]);

        var xAxis = d3.svg.axis()
            .scale(x)
            .orient('bottom')
            .tickFormat(function(d) {
                var v = d.getFullYear();
                return v;
            }.bind(this))
        ;
        var yAxis = d3.svg.axis()
            .scale(y)
            .orient('left')
            .tickFormat(function(d) {
                if (d % 10) return;
                return d;
            })
        ;

        x.domain(this.defaults.dataHighlight.map(function(d) { return d.year; }));
        y.domain([0, d3.max(this.defaults.dataHighlight, function(d) { return d.value; })]);

        chartAll
            .append('g')
                .attr('transform', 'translate(0,' + (this.defaults.innerHeight + this.defaults.margin.top) + ')')
                .call(xAxis)
                .attr('class', function(d) {
                    return 'x axis';
                })
            .selectAll('text')
                .style('text-anchor', 'end')
                .attr('class', 'highlight-x')
                .attr('dx', function() {
                    var r = d3.select(this).node().getBBox();
                    return r.width / 2;
                })
                .attr('dy', function() {
                    var r = d3.select(this).node().getBBox();
                    return r.height;
                })
            ;

        chartAll.append('g')
                .attr('transform', 'translate(0,' + (this.defaults.margin.top) + ')')
                .attr('class', 'y axis')
                .call(yAxis)
            .append('text')
                .attr('x', '-3em')
                .attr('y', '0.35em')
                .text('건수')
        ;

        chartAll.selectAll('.x').selectAll('line')
            .attr('y2', function(d) {
                var v = d.getFullYear();
                if (v % 5 != 0) return;
                return 6;
            })
        ;

        chartAll.selectAll('.y').selectAll('line')
            .attr('x2', function(d) {
                if (d % 10) return;
                return -6;
            })
        ;

        var bar = chartAll.selectAll('bar')
            .data(this.defaults.dataHighlight)
            .enter()
        ;

        bar
            .append('rect')
                .attr('class', function(d) {
                    return 'highlight';
                }.bind(this))
                .attr('transform', 'translate(0,' + (this.defaults.margin.top - 1) + ')')
                .attr('x', function(d) {
                    return x(d.year);
                })
                .attr('width', x.rangeBand())
                .attr('y', function(d) { return y(d.value); })
                .attr('height', function(d) {
                    return this.defaults.innerHeight - y(d.value);
                }.bind(this))
        ;

        bar
            .append('text')
            .attr('class', 'value')
            .attr('height', '1.5em')
            .attr('transform', 'translate(0,' + (this.defaults.margin.top - 1) + ')')
            .text(function(d) {
                return d.value;
            })
            .attr('x', function(d) {
                var r = d3.select(this).node().getBBox();
                return x.rangeBand() / 2 + x(d.year) - (r.width / 2);
            })
            .attr('y', function(d) {
                var r = d3.select(this).node().getBBox();
                return y(d.value) + r.height + 5;
            })
        ;
    }
});

var EXODUS_DATA = {
    '1962': 2,
    '1967': 1,
    '1968': 2,
    '1969': 4,
    '1970': 1,
    '1971': 8,
    '1972': 6,
    '1973': 4,
    '1974': 3,
    '1975': 1,
    '1976': 8,
    '1977': 2,
    '1978': 9,
    '1979': 7,
    '1980': 6,
    '1981': 10,
    '1982': 4,
    '1983': 4,
    '1984': 1,
    '1985': 4,
    '1986': 10,
    '1987': 6,
    '1988': 6,
    '1989': 9,
    '1990': 5,
    '1991': 4,
    '1992': 2,
    '1993': 4,
    '1994': 5,
    '1995': 3,
    '1996': 9,
    '1997': 2,
    '1998': 5,
    '1999': 6,
    '2000': 16,
    '2001': 16,
    '2002': 12,
    '2003': 24,
    '2004': 12,
    '2005': 22,
    '2006': 17,
    '2007': 11,
    '2008': 12,
    '2009': 9,
    '2010': 6,
    '2011': 6,
    '2012': 6,
    '2013': 2,
    '2014': 3,
    '2015': 1
}



var DdangRanking = React.createClass({
    render: function() {
        return (<div className='viz ddang-ranking'>
            <div className='mdl-grid viz-header'>
                <div className='mdl-cell mdl-cell--3-col mdl-cell--1-col-phone'></div>
                <div className='mdl-cell mdl-cell--6-col mdl-cell--10-col-phone'>
                    <h4>친일파별 국가귀속 금액</h4>
                </div>
                <div className='mdl-cell mdl-cell--3-col mdl-cell--1-col-phone'></div>
            </div>
            <div className='mdl-grid'>
                <div className='mdl-cell mdl-cell--12-col mdl-grid--no-spacing'>
                    <div className='content'></div>
                </div>
            </div>
        </div>);
    },
    componentWillMount: function() {
        var dataRaw = {};
        d3.csv.parse(JSON.parse(DDANG_RANKING_CSV)).forEach(function(r) {
            dataRaw[r['친일행위자']] = {
                number: str2Int(r['시가(천원)']),
                area: str2Int(r['면적 합계'])
            };
        });

        this.defaults = {
            dataRaw: dataRaw,
            data: null,
            width: null,
            height: null,
            barHeight: 20,
            padding: 20,
            margin: {
                side: 60
            },
            widthName: null,
            paddingWidthName: 30,
            bars: {},
            duration: 1 * 1000,
            headerLabels: {
                number: '귀속 금액 순으로 보기(천원)',
                area: '토지 면적 /으로 보기(m²)'
            },
            buttonHTML: '<button class=\'mdl-button mdl-js-button mdl-button--raised mdl-button--accent mdl-js-ripple-effect\'></button>'
        }
    },
    componentDidMount: function() {
        this.prepareData();
        this.initialize();
    },
    prepareData: function() {
        var data = [];
        Object.keys(this.defaults.dataRaw).map(function(i) {
            data.push({
                name: i,
                number: this.defaults.dataRaw[i].number,
                area: this.defaults.dataRaw[i].area
            });
        }.bind(this));

        this.defaults.data = data.sort(this.getSortFunc('number'));
    },
    initialize: function() {
        var body = $(this.getDOMNode()).find('.content').get()[0];
        this.defaults.width = $(body).width();
        this.defaults.height = this.defaults.barHeight * this.defaults.data.length;

        if (this.defaults.width < 400) {
            this.defaults.margin.side = 5;
            this.defaults.paddingWidthName = 10;
        }

        this.defaults.header = d3.select(body)
            .append('div')
        ;

        var _this = this;
        this.defaults.header
            .selectAll('div')
            .data(['number', 'area'])
            .enter()
            .append('div')
            .attr('class', function(d) {
                return 'header ' + d;
            })
            //.style('width', (this.defaults.width / 2) + 'px')
            .html(this.defaults.buttonHTML)
            .attr('x', function(d) {
                d3.select(this)
                    .selectAll('button')
                    .text(function() {
                        return _this.defaults.headerLabels[d];
                    })
                    .on('click', function() {
                        _this.defaults.container
                            .transition()
                            .duration(700)
                            .tween('scrollTopContainer', function() {
                                var i = d3.interpolateNumber(this.scrollTop, 0);
                                return function(t) {
                                    this.scrollTop = i(t);
                                }
                            });
                        return _this.sort(d);
                    })
            })
        ;

        this.defaults.container = d3.select(body)
            .append('div')
            .attr('class', 'svg-container')
        ;

        this.svg = this.defaults.container
            .append('svg')
            .attr('width', this.defaults.width)
            .attr('height', this.defaults.height)
        ;

        this.drawName('remove');

        this.defaults.height = (this.defaults.barHeight + (this.defaults.padding / 2)) * this.defaults.data.length;
        this.svg
            .attr('height', this.defaults.height)
        ;

        this.initializeChart('number');
        this.initializeChart('area');
        this.drawName();

        this.drawChart('number');
        this.drawChart('area');

        setTimeout(function() {
            //this.sort('area');
        }.bind(this), 3000);
    },
    drawName: function(remove) {
        var _this = this;
        var maxWidth = 0;
        var height = 0;

        this.defaults.nameNode = this.svg
            .append('g')
            .attr('class', 'name')
        ;

        this.defaults.nameNode
            .selectAll('g')
            .data(this.defaults.data)
            .enter()
            .append('g')
                .sort(this.getSortFunc('number'))
                .attr('transform', function(d, i) {
                    if (! this.defaults.widthName) return;
                    var x = this.defaults.width / 2;
                    return 'translate(' + x + ', ' + i * (this.defaults.barHeight + this.defaults.padding / 2) + ')';
                }.bind(this))
            .append('text')
            .text(function(d) {
                return d.name;
            })
            .attr('y', this.defaults.barHeight / 2)
            .attr('dy', '.35em')
            .attr('x', function() {
                var r = d3.select(this).node().getBBox();
                height = r.height;
                if (r.width > maxWidth) {
                    maxWidth = r.width;
                }
                if (_this.defaults.widthName) {
                    return (r.width / 2) * -1;
                }
            })
        ;

        if (! this.defaults.widthName) {
            this.defaults.widthName = maxWidth + this.defaults.paddingWidthName;
            this.defaults.barHeight = height + 3;
        }

        if (remove) {
            this.svg.selectAll('g.name').remove();
        }
    },
    initializeChart: function(name, sort) {
        var width = (this.defaults.width / 2 - (this.defaults.widthName / 2)) - this.defaults.margin.side;

        this.defaults.bars[name] = {};
        this.defaults.bars[name].x = d3.scale.linear()
            .domain([0, d3.max(this.defaults.data, function(d) { return d[name];})])
            .range([0, width])
        ;

        var bar = this.svg
            .append('g')
            .attr('class', name)
        ;
        var g = bar
            .selectAll('g')
            .data(this.defaults.data)
            .enter()
            .append('g')
                .attr('transform', function(d, i) {
                    if (name == 'area') {
                        x = (this.defaults.width / 2) + (this.defaults.widthName / 2);
                    } else {
                        x = (this.defaults.width / 2) - (this.defaults.widthName / 2);
                    }
                    return 'translate(' + x + ', ' + i *  + (this.defaults.barHeight + this.defaults.padding / 2) + ')';
                }.bind(this))
        ;

        g
            .append('rect')
            .attr('width', function(d) {
                return 0;
            }.bind(this))
            .attr('height', this.defaults.barHeight)
        ;

        var _this = this;
        g.append('text')
            .attr('class', 'value')
            .attr('y', this.defaults.barHeight / 2)
            .attr('dy', '.35em')
        ;
        this.defaults.bars[name].g = g;
    },
    drawChart: function(name) {
        var _this = this;
        var g = this.svg
            .selectAll('g.' + name)
            .selectAll('g')
        ;

        if (name == 'number') {
            g
                .selectAll('rect')
                .attr('transform', function(d) {
                    var r = d3.select(this).node().getBBox();

                    var width = (_this.defaults.width / 2) - (_this.defaults.widthName / 2);
                    x = width - _this.defaults.bars[name].x(d[name]);

                    return 'translate(0, ' + (r.height + 1) + ') rotate(-180)';
                })
            ;
        }

        var _this = this;
        g
            .selectAll('rect')
            .transition()
            .duration(1000)
            .attr('width', function(d) {
                return this.defaults.bars[name].x(d[name]);
            }.bind(this))
        ;

        g
            .selectAll('text')
            .transition()
            .duration(1000)
            .each('end', function(d) {
                d3.select(this)
                    .text(currency(d[name]))
                .attr('x', function(d) {
                    var r = d3.select(this).node().getBBox();
                    var x = _this.defaults.bars[name].x(d[name]);
                    var isShort = x < (r.width + 5);
                    if (name == 'number') {
                        if (isShort) {
                            x -= (x * 2) + r.width + 5;
                        } else {
                            x = -1 * _this.defaults.bars[name].x(d[name]) + 5;
                        }
                    } else {
                        if (isShort) {
                            x += 5;
                        } else {
                            x -= r.width + 5;
                        }
                    }
                    return x;
                })
                ;
            })
        ;
    },
    getSortFunc: function(name) {
        return function(a, b) {
            return b[name] - a[name];
        }
    },
    sort: function(sort) {
        ['number', 'area'].forEach(function(name) {
            this.defaults.bars[name].g
                .sort(this.getSortFunc(sort))
                .transition()
                .duration(this.defaults.duration)
                .attr('transform', function(d, i) {
                    if (name == 'area') {
                        x = (this.defaults.width / 2) + (this.defaults.widthName / 2);
                    } else {
                        x = (this.defaults.width / 2) - (this.defaults.widthName / 2);
                    }
                    return 'translate(' + x + ', ' + i *  + (this.defaults.barHeight + this.defaults.padding / 2) + ')';
                }.bind(this))
                .each('end', function() {
                }.bind(this))
            ;
        }.bind(this));

        this.defaults.nameNode
            .selectAll('g')
                .sort(this.getSortFunc(sort))
                .transition()
                .duration(this.defaults.duration)
                .attr('transform', function(d, i) {
                    if (! this.defaults.widthName) return;
                    var x = this.defaults.width / 2;
                    return 'translate(' + x + ', ' + i * (this.defaults.barHeight + this.defaults.padding / 2) + ')';
                }.bind(this))
        ;
    }
});

var Job = React.createClass({
    render: function() {
        /* http://mbostock.github.io/d3/talk/20111116/pack-hierarchy.html */
        return (<div className='viz job'>
            <div className='mdl-grid mdl-grid--no-spacing'>
                <div className='mdl-cell mdl-cell--12-col'>
                    <div className='content'></div>
                </div>
            </div>
        </div>);
    },
    componentDidMount: function() {
        this.initialize($(this.getDOMNode()).find('.content').get()[0]);
    },
    initialize: function(body) {
        data = this.prepareData(d3.csv.parse(JSON.parse(JOBS)));
        this.draw(body, data);
    },
    draw: function(body, data) {
        var w = $(body).width(),
            h = 500,
            x = d3.scale.linear().range([0, w]),
            y = d3.scale.linear().range([0, h]),
            color = d3.scale.category20b(),
            root,
            node;

        var treemap = d3.layout.treemap()
            .round(false)
            .size([w, h])
            .sticky(true)
            .value(function(d) { return d.size; });

        var svg = d3.select(body).append('div')
            .style('width', w + 'px')
            .style('height', h + 'px')
          .append('svg:svg')
            .attr('width', w)
            .attr('height', h)
          .append('svg:g')
            .attr('transform', 'translate(.5,.5)');

          node = root = data;

          var nodes = treemap.nodes(root)
              .filter(function(d) {
                  return !d.children || d.children.length < 1;
              });

          var cell = svg.selectAll('g')
              .data(nodes)
            .enter().append('svg:g')
              .attr('class', 'cell')
              .attr('transform', function(d) { return 'translate(' + d.x + ',' + d.y + ')'; })
              .on('click', function(d) { return zoom(node == d.parent ? root : d.parent); });

          cell.append('svg:rect')
              .attr('width', function(d) {
                  if (d.dx < 1) return 1;
                  return d.dx - 1;
              })
              .attr('height', function(d) {
                  if (d.dy < 1) return 0;
                  return d.dy - 1;
              })
              .style('fill', function(d) {
                  var c = color(d.parent.name);
                  if (d.parent.name == '기업인') {
                      c = '#ff0000';
                  } else if (d.parent.name == '대학교수') {
                      c = '#75bd7a';
                  }

                  return increase_brightness(c, 15);
              });

          cell.append('svg:text')
              .attr('x', function(d) { return d.dx / 2; })
              .attr('y', function(d) { return d.dy / 2; })
              .attr('dy', '.35em')
              .attr('text-anchor', 'middle')
              .text(function(d) { return d.name; })
              .style('opacity', function(d) {
                  d.w = this.getComputedTextLength();
                  if (d.dy < 20) return 0;
                  return d.dx > d.w ? 1 : 0;
              });

          d3.select(window).on('click', function() { zoom(root); });

          d3.select('select').on('change', function() {
            treemap.value(this.value == 'size' ? size : count).nodes(root);
            zoom(node);
          });

        function size(d) {
          return d.size;
        }

        function count(d) {
          return 1;
        }

        function zoom(target) {
            var light_background = [
                '예술인'
            ];

          var kx = w / target.dx, ky = h / target.dy;

          if (target.depth == 0) {
            svg.selectAll('text.category').transition().duration(500).remove();
          } else {
            var c = svg
                .append('text')
                .attr('class', 'category')
                .attr('x', w)
                .attr('y', h)
                .attr('fill', function () {
                    if (light_background.indexOf(target.name) > -1) {
                        return '#585858';
                    }
                    return '#fff';
                })
                .attr('dy', '4em')
                .style('font-size', '4em')
                .style('opacity', 0)
                .text(target.name)
            ;

            c
                .transition()
                .duration(1000)
                .style('opacity', 1)
                .attr('x', function() {
                    return w - this.getBBox().width - 10;
                })
                .attr('y', function() {
                    return (h / 2) - (this.getBBox().height / 2);
                })
            ;
          }

          x.domain([target.x, target.x + target.dx]);
          y.domain([target.y, target.y + target.dy]);

          var t = svg.selectAll('g.cell').transition()
              .duration(d3.event.altKey ? 7500 : 750)
              .attr('transform', function(d) { return 'translate(' + x(d.x) + ',' + y(d.y) + ')'; });

          t.select('rect')
              .attr('width', function(d) {
                  if (kx * d.dx < 1) return 1;
                  return kx * d.dx - 1;
              })
              .attr('height', function(d) {
                  if (ky * d.dy < 1) return 0;
                  return ky * d.dy - 1;
              })

          t.select('text')
              .attr('x', function(d) { return kx * d.dx / 2; })
              .attr('y', function(d) { return ky * d.dy / 2; })
              .style('opacity', function(d) {
                  if (target.depth == 0 && d.dy < 20) return 0;
                  return kx * d.dx > d.w ? 1 : 0;
              });

          node = target;
          d3.event.stopPropagation();
        }
    },
    prepareData: function(data) {
        var header = {
            category: '대분류',
            name: '행 레이블',
            number: '개수 : 직업'
        };
        var skip = [
            '총합계'
        ];

        var nodeSkel = {
            name: null,
            size: 0,
            children: []
        };

        var parsed = {
            name: '',
            children: []
        };

        var children = {};

        data.forEach(function(o) {
            var c = o[header.category];
            var _name = o[header.name];
            var n = _name.split('/');
            var name = n[n.length - 1];

            var number = o[header.number];
            if (skip.indexOf(name) > -1) return;

            if (c == name) { // this is category
                var node = $.extend({}, nodeSkel);
                node.name = c;
                node.children = [];
                children[c] = node;
                parsed.children.push(node);
                return;
            }

            if (! children[c]) {
                console.error(o);
                return;
            }

            var node = $.extend({}, nodeSkel);
            node.size = parseInt(number);
            node.name = name;
            children[c].children.push(node);
        });

        return parsed;
    }
});

var Viz = React.createClass({
    mixins: [MDLMixin],
    render: function() {
        return (
            <div>
                <DdangRanking />
                <Job />
                <DdangMap />
                <Exodus />
                <DdangBack autoPlay={false} />
            </div>
        );
    }
});

var ChapterLoader = React.createClass({
    getInitialState: function() {
        return {
            chapter: 1
        }
    },
    componentWillMount: function() {
        var chapter = this.props.params.chapter;
        if (! chapter) {
            var page = $('meta[property=page]').attr('content');
            if (! page) {
                chapter = 1;
            } else {
                chapter = parseInt(page);
            }
        }
        this.setState({chapter: chapter});
    },
    render: function() {
        return <Chapter
            key={this.state.chapter}
            data={CHAPTERS[this.state.chapter - 1]}
        />;
    }
});


var Chapter = React.createClass({
    render: function() {
        return (
            <div className='chapter'>
                <div className='content'>{
                    this.state.blocks.length < 1 ?
                        <Block
                            attrs={{
                                type: 'text/html',
                                classNames: 'story compact single',
                                'background-image': 'image/ch1-bg2.jpg'
                            }}
                            source="<h1 class='title'>준비 중입니다.</h1>"
                        />
                    :
                        (<div>{
                        this.state.blocks.map(function(b, index) {
                           return <Block key={index} attrs={b.attrs} source={b.source} />;
                        })}
                        <Discuss hideHeader={true} />
                        </div>)
                }
                </div>
            </div>
        );
    },
    getDefaultProps: function() {
        return {
            data: null,
            source: null
        }
    },
    getInitialState: function() {
        return {
            blocks: []
        }
    },
    componentWillMount: function() {
        if (! this.props.data) return;

        $('#content').addClass('is-active');
        $('#spinner').addClass('is-active');

        loadHTML(
            this.props.data.url,
            function(data) {
                var parsed = parseTemplate(data);
                this.setState({blocks: parsed});
            }.bind(this),
            function() {
                this.setState({blocks: []});
            }.bind(this)
        );
    },
    componentDidUpdate: function() {
        $('.block').each(function() {
            // remove `disabled` button
            $('button.disabled').remove();

            var bg = $(this).attr('data-background-image');
            var dark = $(this).attr('data-background-dark');
            if (! bg) {
                return;
            }

            if (! isMobile(768)) {
                $(this).css({'background-image': 'url(' + bg + ')'});
            }

            if (dark == 'true') {
                $(this).children().addClass('dark-back');
            } else {
                $(this).children().addClass('light-back');
            }
        });

        $('.story .scroll').each(function() {
            setTimeout(function() {
                var left = $(this).find('img').width() / 2;
                var offset = $(this).attr('data-scroll-offset');
                if (! offset) {
                    offset = 0;
                }
                $(this).scrollLeft(parseInt(left) + parseInt(offset));
            }.bind(this), 1000);
        });

        setTimeout(function() {
            $('img.defer').lazyload({
                container: '.mdl-layout__content',
                effect: 'fadeIn',
                data_attribute: 'src',
                threadhold: 200
            });
        }, 100);

        if ($(document.body).width() < 768) {
            $(this.getDOMNode()).find('.responsive table').each(function() {
                var _this = this;
                var headers = [];
                $(_this).find('thead th').each(function(index) {
                    headers[index] = $(this).text();
                });

                $(_this).find('tbody td').each(function(index) {
                    $(this).prepend($('<span />').addClass('header').text(headers[index % headers.length]));
                });
            });
        }

        setTimeout(function(){
            $('#content').removeClass('is-active');
            $('#spinner').removeClass('is-active');
        }, 1000);

    }
});

var Block = React.createClass({
    render: function() {
        return (
        <div className={'mdl-grid mdl-grid--no-spacing block ' + this.props.attrs.classNames}
            data-background-image={this.props.attrs['background-image']}
            data-background-dark={this.props.attrs['background-dark']}
        >
            <div className='mdl-cell mdl-cell--2-col mdl-cell--0-col-phone'></div>
            <div className='mdl-cell mdl-cell--8-col mdl-cell--12-col-phone'
            >
                <div className='block-content'>
                {
                    this.props.source.map ?
                    (
                        this.props.source.map(function(block) {
                            return this.renderSubblock(block);
                        }.bind(this))
                    )
                    :
                    ''
                }
                </div>
            </div>
            <div className='mdl-cell mdl-cell--2-col mdl-cell--0-col-phone'></div>
        </div>
        );
    },
    renderSubblock: function(block) {
        var content;
        if (block.attrs.type == 'text/jsx') {
            content = JSXTransformer.exec(block.source);
        } else if (block.attrs.type == 'text/html') {
            content = <div dangerouslySetInnerHTML={{__html: block.source}} />;
        } else {
            throw 'invalid type, `' + block.attrs.type + '`';
        }

        return (
            <div className={'subblock ' + block.attrs.classNames}>{content}</div>
        );
    },
    componentDidMount: function() {
    }
});

var Discuss = React.createClass({
    getDefaultProps: function() {
        return {
            hideHeader: false
        }
    },
    render: function() {
        return (
        <div className='mdl-grid mdl-grid--no-spacing discuss'>
            <div className='mdl-cell mdl-cell--2-col mdl-cell--0-col-phone'></div>
            <div className='mdl-cell mdl-cell--8-col mdl-cell--12-col-phone discuss'>
            {this.props.hideHeader ?
            ''
            :
                <h4>토론에 참여하세요.</h4>
            }
                <div id='disqus_thread'></div>
            </div>
            <div className='mdl-cell mdl-cell--2-col mdl-cell--0-col-phone'></div>
        </div>
        );
    },
    componentDidMount: function() {
        /* * * CONFIGURATION VARIABLES * * */
        var disqus_shortname = 'newstapa';
        var disqus_title = '친일과 망각: 광복 70년, 뉴스타파 특별기획';
        var disqus_url = 'http://815.newstapa.org/#/discuss';
        var disqus_identifier = disqus_url;
        
        /* * * DON'T EDIT BELOW THIS LINE * * */
        (function() {
            var dsq = document.createElement('script'); dsq.type = 'text/javascript'; dsq.async = true;
            dsq.src = '//' + disqus_shortname + '.disqus.com/embed.js';
            (document.getElementsByTagName('head')[0] || document.getElementsByTagName('body')[0]).appendChild(dsq);
        })();
    }
});

/* configuration */
/* // */

if (typeof MODE == 'undefined') {
    MODE = 'prod';
}

var Route = ReactRouter.Route;
var DefaultRoute = ReactRouter.Route;
var routes = (
    <Route handler={Application}>
        <DefaultRoute handler={ChapterLoader} />
        <Route path='/discuss' handler={Discuss} />
        <Route path='/viz' handler={Viz} />
        <Route path='/:chapter' handler={ChapterLoader} />
    </Route>
);

var ROUTER = ReactRouter.run(routes, ReactRouter.HashLocation, function(Root) {
    React.render(<Root />, document.getElementById('content'));
});

